#pragma once

#include <stdlib.h>
#include "word.h"

//-----------------------------------------------------------------------------
class sorted_wordlist
{
public:
   sorted_wordlist();
   ~sorted_wordlist();
   word &add_elem(const word &elem);

   template<class F>
   bool iterate_list(F f)
   {
      word_elem *we = mBegin;
      while (we)
      {
         if (!f(we->get())) return false;
         we = we->next();
      }
      return true;
   };
private:
   class word_elem
   {
   public:
      word_elem(word *elem);
      word_elem(const word &elem);
      word_elem(word_elem *prev, word_elem *next, word *elem);
      ~word_elem();
      word_elem *next() const;
      word_elem *prev() const;
      word_elem *append(word_elem *elem, bool post = true);
      word &get();
   private:
      word        *mElem;
      word_elem   *mPrev;
      word_elem   *mNext;
   };
private:
   word_elem *mBegin;
   word_elem *mEnd;
};
//-----------------------------------------------------------------------------

