#include "words_file.h"

#include <errno.h>
#include <string.h>
#include <stdio.h>

//-----------------------------------------------------------------------------
exception::exception(int err_no) : mErrno(err_no)
{
}
//-----------------------------------------------------------------------------
const char* exception::what() const
{
   return strerror(mErrno);
}
//-----------------------------------------------------------------------------
int exception::error_code() const
{
   return mErrno;
}
//-----------------------------------------------------------------------------


words_file::words_file(const char *filename)
{
   if ((mWF = fopen(filename, "rm")) == nullptr) throw exception(errno);
}
//-----------------------------------------------------------------------------
words_file &words_file::read_words()
{
   word w;

   while (w.read_from_file(mWF))
   {
      mWL.add_elem(w);
   }

   return *this;
}
//-----------------------------------------------------------------------------
words_file &words_file::print_words()
{
   mWL.iterate_list([](const word &w)
   {
      w.print();
      return true;
   });

   return *this;
}
//-----------------------------------------------------------------------------
words_file::~words_file()
{
   fclose(mWF);
}
//-----------------------------------------------------------------------------

